-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     board.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include grutl.e

include def.e

procedure draw_piece(sequence s, integer x, integer y, integer color)
  -- translate
  for i=1  to length(s) do
     s[i][1] = s[i][1] + x 
     s[i][2] = s[i][2] + y
  end for
  polygon(color,1,s)
  if color != BKCOLOR_ then
     polygon(BRIGHT_MAGENTA,0,s)
  end if
end procedure

------------------------------------------------------------------------------

global procedure Draw_clean_board(integer reverse)
  integer k,x,y
  rectangle({ORGX_-25,ORGY_-24,8*XLEN_+50,8*YLEN_+52},RED,1)
  rectangle({ORGX_-27,ORGY_-26,8*XLEN_+52,8*YLEN_+54},WHITE,0)
  rectangle({ORGX_-2,ORGY_-2,8*XLEN_+4,8*YLEN_+4},WHITE,0)
  k = 1
  for i=0 to 7 do
     for j=0 to 7 do
        rectangle({ORGX_+j*XLEN_,ORGY_+i*YLEN_,XLEN_,YLEN_},SQCOLOR_[k],1)
        k = 1 + remainder(k,2)
     end for
     k = 1 + remainder(k,2)
  end for         
  x = ORGX_- XLEN_/2
  y = ORGY_+ YLEN_/2 - 5
  if reverse = 0 then
     for i = 0 to 7 do
        Writexy({x+2,y+i*YLEN_},sprintf("%s",'8'-i),WHITE,RED)
     end for
  else
     for i = 0 to 7 do
        Writexy({x+2,y+i*YLEN_},sprintf("%s",'1'+i),WHITE,RED)
     end for
  end if
  x = ORGX_+ XLEN_/2 - 4
  y = ORGY_+ YLEN_*8 + 8
  if reverse = 0 then
     for i = 0 to 7 do
        Writexy({x+i*XLEN_,y},sprintf("%s",'A'+i),WHITE,RED)
     end for
  else
     for i = 0 to 7 do
        Writexy({x+i*XLEN_,y},sprintf("%s",'H'-i),WHITE,RED)
     end for
  end if
end procedure

global procedure Show_piece(sequence piece,integer r, integer c, integer col)
  draw_piece(piece, ORGX_+(c-1)*XLEN_, ORGY_+(r-1)*YLEN_, col)
end procedure                                                

global procedure Draw_position(sequence pos,sequence rc)
  sequence s
  integer p
  s = {PAWN,KNIGHT,BISHOP,ROOK,QUEEN,KING}
  for i=1 to 64 do
     p = pos[BOARD][i]
     if p > 0 then
        Show_piece(s[p],rc[i][1],rc[i][2],BROWN)
     elsif p < 0 then
        Show_piece(s[Abs(p)],rc[i][1],rc[i][2],BRIGHT_MAGENTA)
     end if
  end for
end procedure

global procedure Redraw_square(integer r, integer c, integer k)
  if k > 2 or k < 0 then return end if
  rectangle({ORGX_+(c-1)*XLEN_,ORGY_+(r-1)*YLEN_,
             XLEN_,YLEN_},SQCOLOR_[k],1)
end procedure

global procedure Select_sq(integer piece, integer move, integer flag)
  object x
  sequence s
  integer r,c,color
--  x = index2rc(move)
  x = RC[move]
  r = x[1]
  c = x[2]
  s = {}
  if piece = WP then
     s = PAWN      
     color = BROWN
  elsif piece = WN then
     s = KNIGHT
     color = BROWN
  elsif piece = WB then
     s = BISHOP
     color = BROWN
  elsif piece = WR then
     s = ROOK
     color = BROWN
  elsif piece = WQ then
     s = QUEEN
     color = BROWN
  elsif piece = WK then
     s = KING
     color = BROWN
  elsif piece = BP then
     s = PAWN      
     color = BRIGHT_MAGENTA
  elsif piece = BN then
     s = KNIGHT
     color = BRIGHT_MAGENTA
  elsif piece = BB then
     s = BISHOP
     color = BRIGHT_MAGENTA
  elsif piece = BR then
     s = ROOK
     color = BRIGHT_MAGENTA
  elsif piece = BQ then
     s = QUEEN
     color = BRIGHT_MAGENTA
  elsif piece = BK then
     s = KING
     color = BRIGHT_MAGENTA
  else 
    return   
  end if                                                                   
  if flag then
     Show_piece(s,r,c,GRAY)
  elsif not flag then
     Show_piece(s,r,c,color)
  end if
end procedure

-- Changed to using linear board
global procedure Drawposition(sequence board)
  sequence s
  integer p,k         
  k = 1
  for i= 1 to 8 do
     for j=1 to 8 do
        p = board[1][k]
        if p = WP or p = BP then
           s = PAWN
        elsif p = WN or p = BN then
           s = KNIGHT
        elsif p = WB or p = BB then
           s = BISHOP    
        elsif p = WR or p = BR then
           s = ROOK
        elsif p = WQ or p = BQ then
           s = QUEEN
        elsif p = WK or p = BK then
           s = KING
        end if                                                                   
       if p >= WP then
          Show_piece(s,i,j,BROWN)
       elsif p <= BP then
          Show_piece(s,i,j,BRIGHT_MAGENTA)
       end if  
       k = k + 1           
     end for
  end for  

end procedure
                   

global procedure Pr_board(sequence board,sequence move)
   -- format: move = {idx_from, idx_to}
   object x
   integer rf,cf,rt,ct,p,color
   trace(1)
--   x  = index2rc(move[1])
   x = RC[move[1]]
   rf = x[1]
   cf = x[2]
--   x  = index2rc(move[2])
   x = RC[move[2]]
   rt = x[1]
   ct = x[2]
      p = board[1][move[1]]
   -- erase from square
   color = SQ_[move[1]]
   Redraw_square(rf,cf,color)
   -- erase to square
   color = SQ_[move[2]]
   Redraw_square(rt,ct,color)
   -- draw piece to square   
   p = board[1][move[2]]
   if p >= WP then
      color = BROWN
   elsif p <= BP then
      color = BRIGHT_MAGENTA 
   else
      return
   end if
   if p = WP or p = BP then
      Show_piece(PAWN,rt,ct,color)
   elsif p = WN or p = BN then
      Show_piece(KNIGHT,rt,ct,color)
   elsif p = WB or p = BB then
      Show_piece(BISHOP,rt,ct,color)
   elsif p = WR or p = BR then
      Show_piece(ROOK,rt,ct,color)
   elsif p = WQ or p = BQ then
      Show_piece(QUEEN,rt,ct,color)
   elsif p = WK or p = BK then
      Show_piece(KING,rt,ct,color)
   end if  
end procedure

global procedure Update_screen_board(sequence bd, integer move)
   object x
   integer source, dest
   integer rf,cf,rt,ct,p,color,special
   
   source = floor(move/1000)
   dest   = remainder(move,1000)
   if dest > 64 then
     special = floor(dest/100)
     dest = dest - special * 100
   end if
--   x  = index2rc(source)
   x = RC[source]
   rf = x[1]
   cf = x[2]
--   x  = index2rc(dest)
   x = RC[dest]
   rt = x[1]
   ct = x[2]
   -- erase from square
   color = SQ_[source]
   Redraw_square(rf,cf,color)
   color = SQ_[dest]
   Redraw_square(rt,ct,color)
   p = bd[BOARD][dest]
   if p >= WP then
      color = BROWN
   elsif p <= BP then
      color = BRIGHT_MAGENTA 
   else
      return
   end if
   -- draw piece to square   
   if p = WP or p = BP then
      Show_piece(PAWN,rt,ct,color)
   elsif p = WN or p = BN then
      Show_piece(KNIGHT,rt,ct,color)
   elsif p = WB or p = BB then
      Show_piece(BISHOP,rt,ct,color)
   elsif p = WR or p = BR then
      Show_piece(ROOK,rt,ct,color)
   elsif p = WQ or p = BQ then
      Show_piece(QUEEN,rt,ct,color)
   elsif p = WK or p = BK then
      Show_piece(KING,rt,ct,color)
   end if  
end procedure

