-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     capture.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include movegen.e

----------------------------------------------------------------------------
global function King_captures(sequence bd, integer loc, integer side)
  object x,c 
  x = DATA[loc][KING_MV]
  c = {}
  for i=1 to length(x) do
     if side = 1 then
        if bd[BOARD][x[i]] <= BP then
           c =  c & x[i]
        end if
     elsif side = -1 then
        if bd[BOARD][x[i]] >= WP then
           c =  c & x[i]              
        end if
     end if
  end for
  return loc*1000+c  -- a sequence
end function 

global function Promotion_cap(sequence bd, integer loc, integer side)
  object x,c      
  if (side = WHITE_ and floor((loc-1)/8) != 1) or 
     (side = BLACK_ and floor((loc-1)/8) != 6) then  
     return {}
  end if
  c = {}
  if side = WHITE_ then  
     x = DATA[loc][WPAW_CA]
     for i=1 to length(x) do
        if bd[BOARD][x[i]] <= BP then
              c = c & x[i] & 
                      x[i] + 100 & x[i] + 200 & x[i] + 300 & x[i] + 400
        end if 
     end for
  elsif side = BLACK_ and loc < 57 then
     x = DATA[loc][BPAW_CA]
     for i=1 to length(x) do
        if bd[BOARD][x[i]] >= WP then
              c = c & x[i] & 
                      x[i] + 500 & x[i] + 600 & x[i] + 700 & x[i] + 800
        end if            
     end for
  end if
  return loc*1000+c -- a sequence
end function 

global function Pawn_captures(sequence bd, integer loc, integer side)
  object x,c
  c = {}
  if side = WHITE_ and loc > 8 then  
     x = DATA[loc][WPAW_CA]
     for i=1 to length(x) do
        if bd[BOARD][x[i]] <= BP then
           c = c & x[i]
        end if 
     end for
     if bd[ENPASSANT] and find(bd[ENPASSANT],x) then
        c = c & bd[ENPASSANT] + 900
      end if
  elsif side = BLACK_ and loc < 57 then
     x = DATA[loc][BPAW_CA]
     for i=1 to length(x) do
        if bd[BOARD][x[i]] >= WP then
              c = c & x[i]
        end if 
     end for
     if bd[ENPASSANT] and find(bd[ENPASSANT],x) then
        c = c & bd[ENPASSANT] + 900
      end if
  end if
  return Promotion(bd,loc,side) & loc*1000+c -- a sequence
end function 


global function Knight_captures(sequence bd, integer loc, integer side)
  object x,c
  x = DATA[loc][Knig_MV]
  c = {}
  if side = WHITE_ then
     for i=1 to length(x) do
        if bd[BOARD][x[i]] <= BP then
           c = c & x[i]
        end if
     end for
  elsif side = BLACK_ then
     for i=1 to length(x) do
        if bd[BOARD][x[i]] >= WP then
           c = c & x[i]
        end if
     end for
  end if
  return loc*1000+c -- a squence
end function                                                                 

global function Rook_captures(sequence bd, integer loc, integer side)
  object x,c
  x = DATA[loc][HORZ_MV]
  x = x & DATA[loc][VERT_MV]
  c = {}
  if side = WHITE_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] <= BP then
           c = c & x[WEST][i]   
           exit
        elsif bd[BOARD][x[WEST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] <= BP then
           c = c & x[EAST][i]   
           exit
        elsif bd[BOARD][x[EAST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] <= BP then
           c = c & x[NORTH][i]   
           exit
        elsif bd[BOARD][x[NORTH][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] <= BP then
           c = c & x[SOUTH][i]   
           exit
        elsif bd[BOARD][x[SOUTH][i]] >= WP then
           exit
        end if
     end for     
  elsif side = BLACK_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] >= WP then
           c = c & x[WEST][i]   
           exit
        elsif bd[BOARD][x[WEST][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] >= WP then
           c = c & x[EAST][i]   
           exit
        elsif bd[BOARD][x[EAST][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] >= WP then
           c = c & x[NORTH][i]   
           exit
        elsif bd[BOARD][x[NORTH][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] >= WP then
           c = c & x[SOUTH][i]   
           exit
        elsif bd[BOARD][x[SOUTH][i]] <= BP then
           exit
        end if
     end for     
  end if  
  return loc*1000+c -- a sequence
end function                  

global function Bishop_captures(sequence bd, integer loc, integer side)
  object x,c
  x = DATA[loc][Diag_MV]
  c = {}
  if side = WHITE_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] <= BP then
           c = c & x[WEST][i]   
           exit
        elsif bd[BOARD][x[WEST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] <= BP then
           c = c & x[EAST][i]   
           exit
        elsif bd[BOARD][x[EAST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] <= BP then
           c = c & x[NORTH][i]   
           exit
        elsif bd[BOARD][x[NORTH][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] <= BP then
           c = c & x[SOUTH][i]   
           exit
        elsif bd[BOARD][x[SOUTH][i]] >= WP then
           exit
        end if
     end for     
  elsif side = BLACK_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] >= WP then
           c = c & x[WEST][i]   
           exit
        elsif bd[BOARD][x[WEST][i]] <= BP then
           exit                     
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] >= WP then
           c = c & x[EAST][i]   
           exit
        elsif bd[BOARD][x[EAST][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] >= WP then
           c = c & x[NORTH][i]   
           exit
        elsif bd[BOARD][x[NORTH][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] >= WP then
           c = c & x[SOUTH][i]   
           exit
        elsif bd[BOARD][x[SOUTH][i]] <= BP then
           exit
        end if
     end for     
  end if  
  return loc*1000+c -- a sequence
end function                  

global function Queen_captures(sequence bd, integer loc, integer side)
  return Rook_captures(bd,loc,side) & Bishop_captures(bd,loc,side)
end function                  

-----------------------------------------------------------------------------

global function Controlgen(sequence bd,integer side)
  object x,m
  integer k
  m = {}
  if side = WHITE_ then
     for loc = 1 to 64 do 
        if bd[BOARD][loc] = WK then                
           m = m & King_captures(bd,loc,WHITE_) & King_moves(bd,loc,WHITE_)
        elsif bd[BOARD][loc] = WQ then                
           m = m & Queen_captures(bd,loc,WHITE_) & Queen_moves(bd,loc,WHITE_)
        elsif bd[BOARD][loc] = WR then                
           m = m & Rook_captures(bd,loc,WHITE_) & Rook_moves(bd,loc,WHITE_)
        elsif bd[BOARD][loc] = WB then                
           m = m & Bishop_captures(bd,loc,WHITE_) & Bishop_moves(bd,loc,WHITE_)
        elsif bd[BOARD][loc] = WN then                
           m = m & Knight_captures(bd,loc,WHITE_) & Knight_moves(bd,loc,WHITE_)
        elsif bd[BOARD][loc] = WP then                
           x = Pawn_captures(bd,loc,WHITE_) & Pawn_moves(bd,loc,WHITE_)
           if length(x) then -- BUG when called from Controlgen
              m = m & x
           end if
        end if
     end for
  elsif side = BLACK_ then
     for loc = 1 to 64 do 
        if bd[BOARD][loc] = BK then                
           m = m & King_captures(bd,loc,BLACK_) & King_moves(bd,loc,BLACK_)
        elsif bd[BOARD][loc] = BQ then                
           m = m & Queen_captures(bd,loc,BLACK_) & Queen_moves(bd,loc,BLACK_)
        elsif bd[BOARD][loc] = BR then                
           m = m & Rook_captures(bd,loc,BLACK_) & Rook_moves(bd,loc,BLACK_)
        elsif bd[BOARD][loc] = BB then                
           m = m & Bishop_captures(bd,loc,BLACK_) & Bishop_moves(bd,loc,BLACK_)
        elsif bd[BOARD][loc] = BN then                
           m = m & Knight_captures(bd,loc,BLACK_) & Knight_moves(bd,loc,BLACK_)
        elsif bd[BOARD][loc] = BP then                
           x = Pawn_captures(bd,loc,BLACK_) & Pawn_moves(bd,loc,BLACK_)
           if length(x) then
              m = m & x
           end if
        end if
     end for
  end if
  return remainder(m,100)
end function

global function GiveCheck(sequence bd, object move, integer side)
  object x 
  integer source,dest,special,p,loc
  special = 0
  p = 0 loc = 0
  source = floor(move/1000)
  dest   = remainder(move,1000)
  p = bd[BOARD][source]
  loc = source
  if dest > 64 then
     special = floor(dest/100)
     dest = dest - special * 100
     bd[BOARD][dest] = PROMOTION[special]
  else   
     bd[BOARD][dest] = bd[BOARD][source]
  end if
  bd[BOARD][source] = 0
  bd[ENPASSANT] = Pawnhasmovedtwo(bd,source,dest)
  if side = 1 then
     bd[WCONTROL] = Controlgen(bd,1)
     x = find(BK,bd[BOARD])
     return (find(x,bd[WCONTROL]) > 0)
  elsif side = -1 then
     bd[BCONTROL] = Controlgen(bd,-1)
     x = find(WK,bd[BOARD])        
     return (find(x,bd[BCONTROL]) > 0)
  end if 
  return 0
end function

global function Kingincheck(sequence bd, object move, integer side)
  object x 
  integer source,dest,special,p,loc
  special = 0
  p = 0 loc = 0
  source = floor(move/1000)
  dest   = remainder(move,1000)
  p = bd[BOARD][source]
  loc = source
  if dest > 64 then
     special = floor(dest/100)
     dest = dest - special * 100
     bd[BOARD][dest] = PROMOTION[special]
  else   
     bd[BOARD][dest] = bd[BOARD][source]
  end if
  bd[BOARD][source] = 0
  bd[ENPASSANT] = Pawnhasmovedtwo(bd,source,dest)
  if side = 1 then
     bd[BCONTROL] = Controlgen(bd,-1)
     x = find(WK,bd[BOARD])
     return (find(x,bd[BCONTROL]) > 0)
  elsif side = -1 then
     bd[WCONTROL] = Controlgen(bd,1)
     x = find(BK,bd[BOARD])        
     return (find(x,bd[WCONTROL]) > 0)
  end if 
  return 0
end function

global function Init_board(sequence bd)
  object x
  sequence ecp
  integer k
  ecp = ECP_REC
  k=1
  for i=1 to 8 do
    for j=1 to 8 do
       ecp[BOARD][k] = bd[k]
       k = k + 1
    end for
  end for    
  -- set control
  ecp[WCONTROL] = Controlgen(ecp,1)
  ecp[BCONTROL] = Controlgen(ecp,-1)
  return ecp
end function

-----------------------------------------------------------------------------

constant PAWNS=1,KNIGHTS=2,BISHOPS=3,ROOKS=4,QUEENS=5,KINGS=6
constant WPIECES = {WP,WN,WB,WR,WQ,WK}
constant BPIECES = {BP,BN,BB,BR,BQ,BK}

global function CaptureGenerator(sequence bd,integer side)
  object x,c
  sequence pieces
  if side = 1 then
     pieces = WPIECES
  elsif side = -1 then
     pieces = BPIECES
  end if
  c = {}
  for loc = 1 to 64 do 
     if bd[BOARD][loc] = pieces[KINGS] then                
        c = c & King_captures(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[QUEENS] then                
        c = c & Queen_captures(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[ROOKS] then                
        c = c & Rook_captures(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[BISHOPS] then                
        c = c & Bishop_captures(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[KNIGHTS] then                
        c = c & Knight_captures(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[PAWNS] then
        c = c & Pawn_captures(bd,loc,side)
     end if
  end for
  -- Filter captures: keep moves that remove check in king in check
  --               or don't allow check.
  x = {}
  for i=1 to length(c) do
     if remainder(c[i],1000) > 64 then
        x = x & c[i]
     elsif not Kingincheck(bd,c[i],side) then
        x = x & c[i]
     end if            
  end for
  return x
end function
-----------------------------------------------------------------------------
global function MovesGenerator(sequence bd,integer side)
  object x,m,c
  sequence pieces
  if side = 1 then
     pieces = WPIECES
  elsif side = -1 then
     pieces = BPIECES
  end if
  c = CaptureGenerator(bd,side)
  m = Castling(bd,side)
  for loc = 1 to 64 do 
     if bd[BOARD][loc] = pieces[KINGS] then                
        m = m & King_moves(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[QUEENS] then                
        m = m & Queen_moves(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[ROOKS] then                
        m = m & Rook_moves(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[BISHOPS] then                
        m = m & Bishop_moves(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[KNIGHTS] then                
        m = m & Knight_moves(bd,loc,side)
     elsif bd[BOARD][loc] = pieces[PAWNS] then
        m = m & Pawn_moves(bd,loc,side)
     end if
  end for
  -- Filter captures: keep moves that remove check in king in check
  --               or don't allow check.
  x = {}
  for i=1 to length(m) do
     if remainder(m[i],1000) > 64 then
        x = x & m[i]
     elsif not Kingincheck(bd,m[i],side) then
        x = x & m[i]
     end if            
  end for    
--  if length(x) = 0 then
--     x = 1/0
--  end if
  return c & x
end function


