-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     chess.ex
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

without warning
without type_check

include init.e
include player.e
include move.e

procedure donewgame()
  -- start a new game
  mouse_pointer(0)
  Writemessage("  Your Move  ")
  Initgame()
  mouse_pointer(1)
  from_sq = 0 to_sq = 0  
end procedure

procedure dotoggleanalysis()
  -- turn the analysis mode on or off
  if analysis then
     analysis = 0
     position(28,7)
     puts(1,"                                                       ")
     position(29,7)
     puts(1,"                                       ")
     Writemessage("Analysis OFF")
  else
     analysis = 1
     Writemessage("Analysis ON")
  end if
end procedure

procedure dotogglesound()
  -- turn the sound on or off
  if donoise = 1  then
     donoise = 0
     Writemessage("Sound OFF")
  else
     donoise = 1
     Writemessage("Sound ON")
  end if
end procedure

procedure dodepthincrement()
  -- add 2 to the search depth
  depth = depth + 2
  if depth > DMAX then
     depth = DMAX
  end if
  Writemessage(sprintf("depth = %d",depth))
  if DEBUG then
     puts(BUG,"NEW GAME\n" & sprintf("depth: %d\n",depth))
  end if
end procedure

procedure dodepthdecrement()
  -- subtrack 2 to the search depth
  depth = depth - 2
  if depth < 1 then
     depth = 1
  end if
  Writemessage(sprintf("depth = %d",depth))
end procedure

procedure dotakebackmove()
  -- takeback two moves 
  if gameover or ply < 2 then return end if
  ecp = MoveRetracter(ecp,-computer)
  ecp = MoveRetracter(ecp,computer)
  legal = MovesGenerator(ecp,-computer)
--  legal = legal[1] & legal[2]
  if nextplayer = 1 then
     Writemessage("White move")
  else
     Writemessage("Black move")
  end if
  from_sq = 0 to_sq = 0  
end procedure

procedure dogo()
  -- make the computer play
  if gameover then return end if
  computer = -computer  
  Writemessage("COMPUTER")
end procedure

procedure dorotate()
  -- rotate the board position
  if boardrotate = 0 then
     RC = DECRC
     Draw_clean_board(1)
     Draw_position(ecp,RC)
     boardrotate = 1
     Writemessage("ROTATE ON")
  else
     RC = INCRC
     Draw_clean_board(0)
     Draw_position(ecp,RC)
     boardrotate = 0
     Writemessage("ROTATE OFF")
  end if
end procedure

procedure playmove()
  -- play the actual move
  if nextplayer = computer then
     mouse_pointer(0)
     selectmove(nextplayer)
     mouse_pointer(1)    
     if gameover and ecp[CHECK] then
        Writemessage("CHECKMATE")
     elsif gameover then
        Writemessage("DRAW")
     end if
     if donoise then noise() end if
  elsif from_sq and to_sq and nextplayer = -computer then
     mouse_pointer(0)
     playermove(nextplayer)
     mouse_pointer(1)
     if gameover and ecp[CHECK] then
        Writemessage("CHECKMATE")
     elsif gameover then
        Writemessage("DRAW")
     end if
  end if
end procedure

procedure doplaygame()
  -- play the game
  if not gameover then
     if nextplayer = -computer and from_sq and to_sq and from_sq != to_sq then
        legalmove = 0
        playmove()
        if legalmove then
           nextplayer = computer 
        else
           Writemessage("ILLEGAL MOVE")
        end if
        from_sq = 0 to_sq = 0 bd_square = 0 
     elsif nextplayer = computer then
        playmove()
        nextplayer = -computer
     end if
  end if
end procedure

procedure dobuildmove()
  -- construct the player's move
  if gameover then return end if
  if from_sq = 0 then
     if boardrotate then
        from_sq = 65 - bd_square 
     else
        from_sq = bd_square 
     end if
     bd_square = 0
     mouse_pointer(0)
     Select_sq(ecp[BOARD][from_sq],from_sq,ON)
     mouse_pointer(1)
  elsif from_sq and from_sq = to_sq then
     mouse_pointer(0)
     Select_sq(ecp[BOARD][from_sq],from_sq,OFF)
     mouse_pointer(1)
     from_sq = 0 to_sq = 0 bd_square = 0
  elsif from_sq and to_sq = 0 then   
     if boardrotate then
        to_sq = 65 - bd_square 
     else
        to_sq = bd_square 
     end if
     bd_square = 0
     mouse_pointer(0)
     Select_sq(ecp[BOARD][from_sq],from_sq,OFF)
     mouse_pointer(1)
  end if
end procedure          

----------------------------------------------------------------------------

constant EVMOUSE    = 1
constant EVKEYBOARD = 2
constant EVMOVE     = 3

constant QUIT_     = 1001
constant NEW_      = 1002
constant ANALYSIS_ = 1003
constant SOUND_    = 1004
constant INCDEPTH_ = 1005
constant DECDEPTH_ = 1006
constant TAKEBACK_ = 1007
constant GO_       = 1008
constant REVERSE_  = 1009
constant ESC_      = 2001
constant MOVE_     = 3001

constant EVLEFT  = {ANALYSIS_,INCDEPTH_,SOUND_,GO_,NEW_,QUIT_,TAKEBACK_,
                    REVERSE_}
constant EVRIGHT = {0,DECDEPTH_,0,0,0,0,0,0}

constant MSEVENT = 1
constant MS_X    = 2
constant MS_Y    = 3

sequence eventmessage
eventmessage={0,0,0}

function geteventmessage()
  object event
  integer r,c
  if nextplayer = computer then return {0,0,0} end if
  while 1 do
     event = get_mouse()
     if sequence(event) then
        if and_bits(event[MSEVENT],LEFT_DOWN) then
           if event[MS_X] > ORGX_ and event[MS_X] < ORGX_+8*XLEN_ and
              event[MS_Y] > ORGY_ and event[MS_Y] < ORGY_+8*XLEN_ then
              r = floor((event[MS_Y] - ORGY_)/YLEN_) + 1
              c = floor((event[MS_X] - ORGX_)/XLEN_) + 1 
              bd_square = 8*(r-1)+c
              event = {0,0,MOVE_} 
              exit
           else
              for i=1 to length(BUTTONS) do
                 if event[MS_X] > coord[i][1] and 
                    event[MS_X] < coord[i][1]+coord[i][3] and
                    event[MS_Y] > coord[i][2] and 
                    event[MS_Y] < coord[i][2]+coord[i][4] then
                    event = {EVLEFT[i],0,0}                
                    exit
                 end if
              end for
              exit
           end if
        elsif and_bits(event[MSEVENT],RIGHT_DOWN) then
           for i=1 to length(BUTTONS) do
              if event[MS_X] > coord[i][1] and 
                 event[MS_X] < coord[i][1]+coord[i][3] and
                 event[MS_Y] > coord[i][2] and 
                 event[MS_Y] < coord[i][2]+coord[i][4] then
                 event = {EVRIGHT[i],0,0}                
                 exit
              end if
           end for
           exit
        end if
     end if
     event = get_key()
     if event = 27 then
        event = {0,ESC_,0}
        exit
     end if
  end while      
  return event
end function            

procedure main()
  if graphics_mode(18) then
  end if
  initapplication()
  while 1 do
     eventmessage = geteventmessage()
     if eventmessage[EVMOUSE]    = QUIT_     then
        exit
     elsif eventmessage[EVMOUSE] = NEW_      then
        donewgame()
     elsif eventmessage[EVMOUSE] = ANALYSIS_  then
        dotoggleanalysis()
     elsif eventmessage[EVMOUSE] = SOUND_    then
        dotogglesound()
     elsif eventmessage[EVMOUSE] = INCDEPTH_ then
        dodepthincrement()
     elsif eventmessage[EVMOUSE] = DECDEPTH_ then
        dodepthdecrement()
     elsif eventmessage[EVMOUSE] = TAKEBACK_ then
        dotakebackmove()
     elsif eventmessage[EVMOUSE] = GO_       then
        dogo()
     elsif eventmessage[EVMOUSE] = REVERSE_  then
        dorotate()
     elsif eventmessage[EVKEYBOARD] = ESC_   then
        exit
     elsif eventmessage[EVMOVE] = MOVE_      then
        dobuildmove()
     end if
     doplaygame()
  end while
  mouse_pointer(0)
  if graphics_mode(-1) then
  end if
end procedure

main()

