-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     def.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include data.e                                   

global constant WHITE_ =  1
global constant BLACK_ = -1

global constant RRR = "abcdefgh"
global constant CCC = "12345678"

global constant ON   = 1
global constant OFF  = 0
global constant SHOWMOVE  = 0
global constant INFINITY = 9999
global constant PIECES = " NBRQK"
global constant DMAX = 9
global constant TMAX = 60.0
global constant ZTIME = 1.0

global object   mess           
global object   scoretab
global sequence RC,INCRC,DECRC
global sequence legal
global sequence coord
global sequence ecp, ecp_list
global sequence moves_list
global sequence lastmove
global sequence move_stack
global sequence piecetable
global sequence hashtable,ttable,atable
global sequence mainline
global sequence wpawnmo,bpawnmo,knightmo,bishopmo,rookmo,queenmo,kingmo
global atom     tstart,tstop
global integer  analysis,boardrotate
global integer  computer,nextplayer
global integer  from_sq,to_sq,bd_square
global integer  legalmove
global integer  donoise
global integer  realmove
global integer  dmax 
global integer  cnt50
global integer  gameover
global integer  inthebook
global integer  optr
global integer  movecount
global integer  ply       -- number of ply from beginning of game
global integer  depth     -- absolute depth from ply
global integer  try
global integer zscore
----------------------------------------------------------------------------

-- Stuff related to recording position
global constant MASK_WCK = 1 -- 0001 white can castle king side
global constant MASK_WCQ = 2 -- 0010 black can castle queen side
global constant MASK_BCK = 4 -- 0100 white can castle king side
global constant MASK_BCQ = 8 -- 1000 black can castle queen side
 
global constant W_TURN = 1
global constant B_TURN = 2

global constant BOARD     = 1  -- Chess board
global constant TURN      = 2  -- 1 for White, -1 for Black
global constant LMOVE     = 3  -- last move
global constant CAPTURE   = 4  -- Piece if captured or 0
global constant PLYNO     = 5  -- half move number
global constant CHECK     = 6  -- 1 if white 2 if black 0 if none
global constant CASTLING  = 7  -- castling flag (1111)
global constant ENPASSANT = 8  -- en passant square index
global constant HASH      = 9  -- position hash key
global constant FORCES    = 10 -- Total number of pieces (no pawn,no kings)
global constant PHASE     = 11 -- 1=opening 2=middle 3=ending
global constant WCONTROL  = 12 -- square controlled by WHITE
global constant BCONTROL  = 13 -- square controlled by BLACK
global constant DSCORE    = 14 -- Dynamic score
global constant HCODE     = 15 -- Position id for hash table
global constant WMATER    = 16 -- 
global constant BMATER    = 17 --

global constant ECP_REC= {repeat(0,64),1,0,0,0,0,15,0,0,14,1,{},{},0,0,0,0}

global constant WP = 1
global constant WN = 2
global constant WB = 3
global constant WR = 4
global constant WQ = 5
global constant WK = 6
global constant BP = -1
global constant BN = -2
global constant BB = -3
global constant BR = -4
global constant BQ = -5
global constant BK = -6

global constant STARTING_POSITION = {
BR,BN,BB,BQ,BK,BB,BN,BR,
BP,BP,BP,BP,BP,BP,BP,BP,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
WP,WP,WP,WP,WP,WP,WP,WP,
WR,WN,WB,WQ,WK,WB,WN,WR}


--                           | White     | Black  | 
--                           1  2  3  4  5  6  7  8                                             
global constant PROMOTION = {WN,WB,WR,WQ,BN,BB,BR,BQ}

global constant CENTERSPACE = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,5,5,0,0,0,
0,0,0,5,5,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0}   


global constant SOURCE   = 1
global constant SRC      = 1
global constant DEST     = 2
global constant SPECIAL  = 3
global constant SENTITY  = 4
global constant DENTITY  = 5
global constant MOVE_REC = {SRC,DEST,SPECIAL,SENTITY,DENTITY}

------------------------------HASHING---------------------------------------
global constant BESTMOVE = 1
global constant SCORE    = 2
global constant BOUND    = 3  -- 1 = lower 2 = upper 3 = exact
global constant DEPTH    = 4
global constant CODE     = 5  -- pos[FORCES] tot pieces * pos[TURN]
global constant HASH_REC = {0,0,0,0,0}                             
global constant WSIDE = 1, BSIDE = 2
global constant HASHIDX = {WP,WN,WB,WR,WQ,WK,BP,BN,BB,BR,BQ,BK}

global constant HASHTABSIZE = 32768

----------------------------- global constants -----------------------------

global constant TRUE_  = 1
global constant FALSE_ = 0

global constant ORGX_ = 50 
global constant ORGY_ = 40
global constant XLEN_ = 40 
global constant YLEN_ = 40 
                                          
global constant FROM_ = 1, TO_  = 2
global constant ROW_  = 1, COL_ = 2

global constant NORTH_ = -1
global constant SOUTH_ =  1

global constant SQ_ = {1,2,1,2,1,2,1,2,
                      2,1,2,1,2,1,2,1,
                      1,2,1,2,1,2,1,2,  
                      2,1,2,1,2,1,2,1,
                      1,2,1,2,1,2,1,2,  
                      2,1,2,1,2,1,2,1,
                      1,2,1,2,1,2,1,2,  
                      2,1,2,1,2,1,2,1}

include graphics.e

global constant SQCOLOR_ = {WHITE,MAGENTA}
global constant BKCOLOR_ = BLACK

global constant PAWN = floor({{22,8},{28,8},{32,12},{32,18},{28,22},{28,34},{36,40},
{38,46},{12,46},{14,40},{22,34},{22,22},{18,18},{18,12},{22,8}} * 4/5)

global constant KNIGHT = floor({{14,20},{32,12},{38,8},{38,30},{34,36},{40,46},{10,46},
{26,34},{26,26},{14,26}} * 4/5)

global constant BISHOP = floor({{10,46},{13,40},{22,34},{16,24},{16,14},{25,4},{34,14},
{34,24},{28,34},{37,40},{40,46}} * 4/5)

global constant ROOK = floor({{10,46},{10,14},{14,14},{14,18},{18,18},{18,14},{24,14},
{24,18},{26,18},{26,14},{32,14},{32,18},{36,18},{36,14},{40,14},{40,46}} * 4/5)

global constant QUEEN = floor({{10,46},{13,40},{22,34},{14,26},{10,8},{18,16},{25,4},
{32,16},{40,8},{36,26},{28,34},{37,40},{40,46}} * 4/5)

global constant KING = floor({{10,46},{13,40},{22,34},{14,26},{14,14},{24,14},{24,12},
{22,12},{22,10},{24,10},{24,8},{26,8},{26,10},{28,10},{28,12},{26,12}, 
{26,14},{36,14},{36,26},{28,34},{37,40},{40,46}} * 4/5)



----------------------------- global variables -----------------------------

global function Abs(integer x)
   if x < 0 then x = -x end if
   return x
end function

-- BLACK = 0,  -- in graphics modes this is "transparent"
--                BLUE  = 1,
--                GREEN = 2,
--                CYAN =  3,
--                RED   = 4,
--                MAGENTA = 5,
--                BROWN = 6,
--                WHITE = 7,
--                GRAY  = 8,
--                BRIGHT_BLUE = 9,
--                BRIGHT_GREEN = 10,
--                BRIGHT_CYAN = 11,
--                BRIGHT_RED = 12,
--                BRIGHT_MAGENTA = 13,
--                YELLOW = 14,
--                BRIGHT_WHITE = 15


