-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     hash.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include def.e

hashtable = repeat(repeat(HASH_REC,HASHTABSIZE),2)

global function createpiecetable()
  sequence x,pt
  integer n,cnt
  cnt = 1 x = {}
  while cnt <= 768 do
     n = rand(HASHTABSIZE)
     if not find(n,x) then
        x = x & n
        cnt = cnt + 1
     end if
  end while
  pt = repeat(repeat(0,64),12)
  cnt = 1
  for i=1 to 12 do
     for j=1 to 64 do
        pt[i][j] = x[cnt]
        cnt = cnt + 1
     end for
  end for
  return pt
end function

global function hashinit(sequence pos)
  integer h,k
  h = 0
  for i=1 to 64 do
     k = find(pos[BOARD][i],HASHIDX)
     if k then
        h = xor_bits(h,piecetable[k][i])
     end if   
  end for                  
  return h
end function

global function hash(sequence pos)
  integer h,src,dest,special,k,mv
  integer movingpiece,capturedpiece
  sequence pt
  pt = piecetable
  h = pos[HASH]                  
  mv = pos[LMOVE]
  src = floor(mv/1000)
  dest = remainder(mv,100)
  special = floor(remainder(mv,1000)/100)
  movingpiece = pos[BOARD][dest]
  capturedpiece = pos[CAPTURE]
  if special = 0 then
     if mv = 61063 then
        pos[HASH] = xor_bits(pos[HASH],pt[6][61])
        pos[HASH] = xor_bits(pos[HASH],pt[6][63])
        pos[HASH] = xor_bits(pos[HASH],pt[4][64])
        pos[HASH] = xor_bits(pos[HASH],pt[4][62])
     elsif mv = 61059 then
        pos[HASH] = xor_bits(pos[HASH],pt[6][61])
        pos[HASH] = xor_bits(pos[HASH],pt[6][59])
        pos[HASH] = xor_bits(pos[HASH],pt[4][57])
        pos[HASH] = xor_bits(pos[HASH],pt[4][60])
     elsif mv = 5007 then
        pos[HASH] = xor_bits(pos[HASH],pt[12][5])
        pos[HASH] = xor_bits(pos[HASH],pt[12][7])
        pos[HASH] = xor_bits(pos[HASH],pt[10][8])
        pos[HASH] = xor_bits(pos[HASH],pt[10][6])
     elsif mv = 5003 then
        pos[HASH] = xor_bits(pos[HASH],pt[12][5])
        pos[HASH] = xor_bits(pos[HASH],pt[12][3])
        pos[HASH] = xor_bits(pos[HASH],pt[10][1])
        pos[HASH] = xor_bits(pos[HASH],pt[10][4])
     else 
        if capturedpiece = 0 then             
           k = find(movingpiece,HASHIDX)
           pos[HASH] = xor_bits(pos[HASH],pt[k][src])
           pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
        else
           k = find(capturedpiece,HASHIDX)
           pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
           k = find(movingpiece,HASHIDX)
           pos[HASH] = xor_bits(pos[HASH],pt[k][src])
           pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
        end if  
     end if
  elsif special = 9 then
  -- prise en passant            
     if movingpiece = WP then
        pos[HASH] = xor_bits(pos[HASH],pt[7][dest+8])
        pos[HASH] = xor_bits(pos[HASH],pt[1][src])
        pos[HASH] = xor_bits(pos[HASH],pt[1][dest])
     else
        pos[HASH] = xor_bits(pos[HASH],pt[1][dest-8])
        pos[HASH] = xor_bits(pos[HASH],pt[7][src])
        pos[HASH] = xor_bits(pos[HASH],pt[7][dest])
     end if
  elsif special >= 1 and special <= 8 then
  -- promotion
     if src >= 1 and src <= 8 then
        pos[HASH] = xor_bits(pos[HASH],pt[1][src])
        if capturedpiece then
           k = find(capturedpiece,HASHIDX)
           pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
        end if
        k = find(movingpiece,HASHIDX)
        pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
     else
        pos[HASH] = xor_bits(pos[HASH],pt[7][src])
        if capturedpiece then
           k = find(capturedpiece,HASHIDX)
           pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
        end if
        k = find(movingpiece,HASHIDX)
        pos[HASH] = xor_bits(pos[HASH],pt[k][dest])
     end if
  end if
  return pos[HASH]
end function

