-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     init.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include debug.e

include grutl.e
include pushbut.e
include meswin.e
include meter.e
include board.e
include mouse.e
include data.e
include def.e
include mob.e
--include movgen.e
include movegen.e
include book.e
include search.e
include hash.e 
include noise.e

include get.e
include fast_key.e

global function index2rc(integer m)
  integer r,c
  c = remainder(m,8)
  if c = 0 then
     c = 8
  end if
  r = floor((m-1)/8) + 1
  return {r,c}
end function 

INCRC = {}
for i=1 to 64 do
   INCRC = append(INCRC,index2rc(i))
end for               

DECRC = {}
for i=64 to 1 by -1 do
   DECRC = append(DECRC,INCRC[i])
end for               

global constant BUTTONS = {
   {{450,150,70,30}, "ANALYSIS",  COLOR_LABEL,COLOR_BUTTON,0,1},
   {{450,190,70,30}, "DEPTH", COLOR_LABEL,COLOR_BUTTON,0,1},
   {{450,230,70,30}, "SOUND",  COLOR_LABEL,COLOR_BUTTON,0,1},
   {{450,270,70,30}, "GO", COLOR_LABEL,COLOR_BUTTON,0,1},
   {{530,150,70,30}, "NEW",  COLOR_LABEL,COLOR_BUTTON,0,1},
   {{530,190,70,30}, "QUIT", COLOR_LABEL,COLOR_BUTTON,0,1},
   {{530,230,70,30}, "TAKEBACK", COLOR_LABEL,COLOR_BUTTON,0,1},
   {{530,270,70,30}, "ROTATE",COLOR_LABEL,COLOR_BUTTON,0,1}}

-----------------------------------------------------------------------------

global procedure Info()
  integer x,y
  x = 450
  y = 320 
  Writexy({x,y},"CHESS PROGRAM v1.6a",YELLOW,BLACK)
  Writexy({x,y+16},"Written in EUPHORIA",BRIGHT_RED,BLACK)
  Writexy({x,y+2*16},"by Normand M. Blais",BRIGHT_RED,BLACK)
  Writexy({x,y+3*16},"August 1998",BRIGHT_RED,BLACK)
end procedure

global procedure Initgame() 
  integer fp
  object spare
  from_sq = 0 to_sq = 0  
  moves_list = {}
  move_stack = {}
  inthebook  = 1
  optr       = 1
  depth      = 3
  lastmove   = {}
  movecount = 0
  ply = 0
  cnt50 = 0
  gameover = 0
  donoise = 0
  realmove = 0
  legal = {}
  computer = -1
  nextplayer = 1 
  legalmove = 0
  boardrotate = 0
  RC = INCRC
  ttable = {{},{}} -- transposition table
  atable = {{},{}} -- age table 
  -- take care of the screen_board
  if DEBUG then
     puts(BUG,"NEW GAME\n" & sprintf("depth: %d\n",depth))
  end if
  -- takes care of the memory board
  ecp = Init_board(STARTING_POSITION)
  ecp[WMATER] = material(ecp,1)
  ecp[BMATER] = material(ecp,-1)
  legal = MovesGenerator(ecp,nextplayer)
--  legal = legal[1] & legal[2]   
  zscore = 0
  Draw_clean_board(0)
  Draw_position(ecp,RC)
end procedure

global procedure initapplication()
  object spare
  spare = palette(MAGENTA,{13,27,33})
  spare = palette(BROWN,{38,26,15})
  spare = palette(BRIGHT_MAGENTA,{0,0,0})
  spare = palette(BLACK,{0,27,0}) 
  spare = palette(BROWN,{59,57,47})
  spare = palette(RED,{25,21,7})
--
  Init_controls(BUTTONS)
  Controls(length(BUTTONS))
  coord = {}       
  for i=1 to length(BUTTONS) do
     coord = append(coord,Get_loc_but(i))
  end for             
  Meter(1)
  Messagewindow()
  Writemessage("  YOUR MOVE  ")
  Info()
  init_mobility()
  Initgame()
  piecetable = createpiecetable()
  ecp[HASH] =  hashinit(ecp)
  mouse_events(LEFT_DOWN+RIGHT_DOWN)
  analysis = 0
  mouse_pointer(1)
end procedure

-----------------------------------------------------------------------------

