-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     meter.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include graphics.e

constant METERXLOC     = 450
constant METERYLOC     = 100
constant METERLENGTH   = 150
constant METERHEIGHT   = 20 
constant METERCOLOR    = CYAN
constant METERBARCOLOR = BLACK --BRIGHT_CYAN

atom meter_steps

procedure Set_horizontal_meter(integer color,
  integer x, integer y, integer xlen, integer ylen)
  polygon(color,0,{{x,y},{x+xlen,y},{x+xlen,y+ylen},{x,y+ylen},{x,y}})
end procedure

procedure update_meter(integer color, 
  integer x, integer y, integer ylen, integer value)
  if value = 0 then
     polygon(0,1,{{x,y},{x+value,y},{x+value,y+ylen},{x,y+ylen},{x,y}})
  else
     polygon(color,1,{{x,y},{x+value,y},{x+value,y+ylen},{x,y+ylen},{x,y}})
  end if
end procedure

-----------------------------------------------------------------------------
-- Interfaces
-----------------------------------------------------------------------------
global procedure Meter(integer n)
  Set_horizontal_meter(METERCOLOR,METERXLOC,METERYLOC,
      METERLENGTH,METERHEIGHT)
  meter_steps = floor((METERLENGTH-1)/n)
end procedure

global procedure Runmeter(integer v)
  update_meter(METERBARCOLOR,METERXLOC+2,METERYLOC+2,METERHEIGHT-4,
               v*meter_steps) 
end procedure

global procedure Resetmeter(integer v)
  for i = 1 to v do
     update_meter(GRAY,METERXLOC+2,METERYLOC+2,METERHEIGHT-4,
               v*meter_steps) 
  end for
end procedure

-----------------------------------------------------------------------------
-- How to use Meter.e
-- 1. Set constant values
-- 2. Call meter and supply the number of units. The procedure computes
--    the unit size.
-- 3. Call Runmeter repetitively with an increasing nominal value from 1 to
--    the total of units.
-----------------------------------------------------------------------------
-- meter.e

--include grutl.e

--include get.e
--object spare

--integer num_of_moves

--num_of_moves = 13
                              
--Video() -- Initiate graphics mode
                                         
--Meter(num_of_moves)

--spare = wait_key()

--for i=1 to num_of_moves do
--  Runmeter(i)
--  spare = wait_key()
--end for


--Text() -- Return to text mode

