-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     mob.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include data.e
include def.e

--global constant KING_MV = 1
--global constant HORZ_MV = 2
--global constant VERT_MV = 3
--global constant Diag_MV = 4
--global constant Knig_MV = 5
--global constant WPAW_MV = 6
--global constant WPAW_CA = 7
--global constant BPAW_MV = 8
--global constant BPAW_CA = 9
--global constant WEST = 1
--global constant EAST = 2
--global constant NORTH = 3
--global constant SOUTH = 4
--global constant NE  = 1
--global constant SE  = 2
--global constant SW  = 3
--global constant NW  = 4

global function whitepawnmobility()
  sequence mo
  mo = repeat(0,64)
  for i=1 to 64 do
     mo[i] = length(DATA[i][WPAW_MV])
     for k=1 to  length(DATA[i][WPAW_CA]) do
        mo[i] = mo[i] + CENTERSPACE[DATA[i][WPAW_CA][k]]
     end for 
     if i>=1 and i<=8 then
        mo[i] = mo[i] + 5
     end if
  end for  
  return mo
end function

global function blackpawnmobility()
  sequence mo
  mo = repeat(0,64)
  for i=1 to 64 do
     mo[i] = length(DATA[i][BPAW_MV])
     for k=1 to  length(DATA[i][BPAW_CA]) do
        mo[i] = mo[i] + CENTERSPACE[DATA[i][BPAW_CA][k]]
     end for
     if i>=57 and i<=64 then
        mo[i] = mo[i] + 5
     end if
  end for  
  return mo
end function

global function rookmobility()
  sequence mo 
  object x                        
  mo = repeat(0,64)
  for i=1 to 64 do
     mo[i] = length(DATA[i][HORZ_MV]) + length(DATA[i][VERT_MV])
     for k=1 to  length(DATA[i][HORZ_MV]) do            
        x = DATA[i][HORZ_MV][k]
        if length(x) then
           for kk=1 to length(x) do
              mo[i] = mo[i] + CENTERSPACE[DATA[i][HORZ_MV][k][kk]]
           end for
        end if
     end for
     for k=1 to  length(DATA[i][VERT_MV]) do
        x = DATA[i][VERT_MV][k]
        if length(x) then
           for kk=1 to length(x) do
              mo[i] = mo[i] + CENTERSPACE[DATA[i][VERT_MV][k][kk]]
           end for
        end if
     end for
  end for
  return mo
end function
 
global function bishopmobility()
  sequence mo 
  object x
  mo = repeat(0,64)
  for i=1 to 64 do
     mo[i] = length(DATA[i][Diag_MV])     
     for k=1 to  length(DATA[i][Diag_MV]) do
        x = DATA[i][Diag_MV][k]
        if length(x) then
           for kk=1 to length(x) do
              mo[i] = mo[i] + CENTERSPACE[DATA[i][Diag_MV][k][kk]]
           end for
        end if
     end for
  end for 
  return mo
end function

global function knightmobility()
  sequence mo                         
  mo = repeat(0,64)
  for i=1 to 64 do
     mo[i] = length(DATA[i][Knig_MV])
     for k=1 to  length(DATA[i][Knig_MV]) do
        mo[i] = mo[i] + CENTERSPACE[DATA[i][Knig_MV][k]]
     end for
  end for
  return mo
end function

global function queenmobility()
  return rookmobility() + bishopmobility()
end function


global function kingmobility()
  sequence mo                         
  mo = repeat(0,64)
  for i=1 to 64 do
     mo[i] = length(DATA[i][KING_MV])
     for k=1 to  length(DATA[i][KING_MV]) do
        mo[i] = mo[i] + CENTERSPACE[DATA[i][KING_MV][k]]
     end for
  end for
  return mo
end function

global procedure init_mobility()
  wpawnmo  = whitepawnmobility()
  bpawnmo  = blackpawnmobility()
  knightmo = knightmobility()
  bishopmo = bishopmobility()
  rookmo   = rookmobility()
  queenmo  = queenmobility()
  kingmo   = kingmobility()
end procedure

-- procedure test()
-- object spare
-- integer z
-- spare = kingmobility()
-- z=1
-- for i=1 to 8 do
--    for j=1 to 8 do
--    printf(1,"%2d ", spare[z])
--    z = z + 1
--    end for                      
--    puts(1,"\n")
-- end for
-- end procedure


