-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     move.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include init.e

constant KIDDING = {
"Watch out!","Not Bad!","Be patient!","I love Chess!","I hate losing.",
"Don't cheat!","EUPHORIA POWER!","Go figure!?","What's next?","Nice move!?",
"Great game!?","I'm thinking!","Let's rock!"}

constant FIRSTMOVE = {53037,52036,51035}

global procedure selectmove(integer side)
  object x,moves,junk,spare
  atom secs,tott
  sequence pos,sidx,scr
  integer special,k
  integer score,max,idx,len,a,b,xside
  xside = -side
  if DEBUG then
     puts(BUG,"WHITE LAST MOVE: " & cnvtmove(ecp) & "\n")
     puts(BUG,sprintf("SCORE: %d\n", Score(ecp,xside)))
  end if
  -- See if still in the book
  if inthebook and side = -1 then
     x = Bookmove(openings)
     if length(x) = 0 then
        inthebook = 0
     else
        if not compare(x,"e8g8") then
           x = 5007
        elsif not compare(x,"e8c8") then
           x = 5003
        else
           x = Text2move(x)
        end if
        ecp = MoveExecutor(ecp,x,side,ON)
        if DEBUG then
           puts(BUG,"COMPUTER PLAYS: " & cnvtmove(ecp) & "\n")
           puts(BUG,sprintf("SCORE: %d\n", Score(ecp,side)))
        end if  
        legal = MovesGenerator(ecp,xside)
--        legal = legal[1] & legal[2]
        return
     end if
  elsif side = 1 and ply = 0 then
     x = FIRSTMOVE[rand(3)]
     ecp = MoveExecutor(ecp,x,side,ON)
     if DEBUG then
        puts(BUG,"COMPUTER PLAYS: " & cnvtmove(ecp) & "\n")
        puts(BUG,sprintf("SCORE: %d\n", Score(ecp,side)))
     end if  
     legal = MovesGenerator(ecp,xside)
--     legal = legal[1] & legal[2]
     inthebook = 0
     return
  end if
  legal = MovesGenerator(ecp,side)
--  moves = legal[1] & legal[2]
  moves = legal
  if length(moves) = 0 then
     gameover = 1 
     return
  end if
  a = -INFINITY
  b =  INFINITY
  junk = retrievehash(ecp,side)
  if length(junk) != 0 then
     if junk[BOUND] = 3 and junk[DEPTH] >= depth then
        if find(junk[MOVE],moves) then
           ecp = MoveExecutor(ecp,junk[MOVE],side,ON)
           if DEBUG then
              puts(BUG,"BLACK PLAYS: " & cnvtmove(ecp) & "\n")
              puts(BUG,sprintf("SCORE: %d\n", Score(ecp,side)))
           end if
           legal = MovesGenerator(ecp,xside)       
--           legal = legal[1] & legal[2]
           if length(legal) = 0 then
              if ecp[CHECK] then
                 Writemessage("Checkmate")
              else
                 Writemessage("Stalemate")
              end if
              gameover = 1
           end if
           return 
        elsif junk[BOUND] = 1 then
           a = junk[SCORE]
           b =  INFINITY
        elsif junk[BOUND] = 2 then
           a = -INFINITY
           b = junk[SCORE]
        end if
    end if
  end if
  moves = examine(ecp,side,moves)
  if find(5007,moves) or find(5003,moves) or
     find(61063,moves) or find(61059,moves) then
     k = 1
  else
     k = 0
  end if
  pos = {}
  len = length(moves)
  if DEBUG then
     puts(BUG,"BLACK'S LEGAL MOVES:\n")
  end if
  scr = {}
  for i=1 to len do
     pos = append(pos,MoveExecutor(ecp,moves[i],side,OFF))
     if DEBUG then
        puts(BUG,cnvtmove(pos[i]) & ",")
        if remainder(i,10) = 0 then
           puts(BUG,"\n")
        end if
     end if
  end for
  spare = {}
  Meter(len)
  Resetmeter(len)
  idx = 1
  max = 1
  try = 1                      
  Writemessage(KIDDING[rand(length(KIDDING))])
  mainline = repeat(repeat({},10),len)
  for i=1 to len do
     mainline[i][1] = cnvtmove(pos[i])
  end for
  score = 0
  dmax = depth
  secs = {}
  for i=1 to len do                  
     Runmeter(i)
     tstart = time()
     score = search(pos[i],side,1,depth,a,b) + pos[i][DSCORE]
     if pos[i][PHASE] = 1 then
        if pos[i][LMOVE] = 19002 or
           pos[i][LMOVE] = 12002 or
           pos[i][LMOVE] = 22007 or
           pos[i][LMOVE] = 13007 or
           pos[i][LMOVE] = 46063 or
           pos[i][LMOVE] = 53063 or
           pos[i][LMOVE] = 43058 or
           pos[i][LMOVE] = 52058 then
           score = score - 13
        elsif Abs(pos[i][BOARD][remainder(pos[i][LMOVE],100)]) = WK then
           score = score - 13
        end if
     end if                                     
     if i=1 then 
        max = score 
        if k then max = max + 50 end if 
        idx = 1
     else
        if score > max then max = score idx = i end if
     end if                                        
     if max > a then a = max-180 end if
     tstop = time()
     secs = append(secs,tstop-tstart)
     scr = append(scr,score)
     try = try + 1
  end for
  if not ecp[CHECK] and not ecp[CAPTURE] then
     x = {}
     for i=1 to length(scr) do
        if scr[i] = max then
           x = x & i
        end if
     end for  
     if length(x) > 1 then
        max = Score(pos[x[1]],side)
        idx = x[1]
        for i=2 to length(x) do
           score = Score(pos[x[i]],side)
           if score > max then
              max = score
              idx = x[i]
           end if
        end for
     end if
  end if
  if analysis then
     position(28,7)
     puts(1,"                                                                  ")
     position(28,7)
     for i=1 to length(mainline[idx]) do
        puts(1,mainline[idx][i] & ' ')
     end for
  end if          
  x = moves[idx]    
  ecp = MoveExecutor(ecp,x,side,ON)
  zscore = Score(ecp,side)
  if analysis then
     position(29,7)
     puts(1,"                                                                  ")
     position(29,7)
--     printf(1,"Computer score: %.2f",(Score(ecp,side)/100))
     printf(1,"Computer score: %.2f",(zscore/100))
  end if          
  if DEBUG then
     puts(BUG,"\nALL SCORES: \n")
     for i=1 to length(scr) do
        puts(BUG,sprintf("%d,",scr[i]))
        if remainder(i,10) = 0 then
           puts(BUG,"\n")
        end if
     end for
     tott = 0.0
     puts(BUG,"\nALL TIMES: \n")
     for i=1 to length(secs) do
        puts(BUG,sprintf("%.2f,",secs[i]))
        if remainder(i,10) = 0 then
           puts(BUG,"\n")
        end if
        tott = tott + secs[i]
     end for
     puts(BUG,sprintf("\nTOTAL TIMES: %.2f\n",tott))
     puts(BUG,"\nBLACK PLAYS: " & cnvtmove(ecp) & "\n")
     puts(BUG,sprintf("MAX: %d\n", max))
     puts(BUG,sprintf("SCORE: %d\n", Score(ecp,side)))
  end if
  legal = MovesGenerator(ecp,xside)
--  legal = legal[1] & legal[2]
  if length(legal) = 0 then
     if ecp[CHECK] then
        Writemessage("CHECKMATE")
     else
        Writemessage("STALEMATE")
     end if
     gameover = 1 
  end if
end procedure


