-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     movegen.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

include def.e      
include data.e

global function Move2Text(sequence pos, integer m) 
  integer f, t, r, c, p
  sequence s          
  s = {}
  f = floor(m/1000)
  t = remainder(m,1000)
  if t > 64 then
     return "error"
  end if
  r = 8 - floor((f-1)/8)
  c = remainder(f,8)
  if c = 0 then
     c = 8
  end if
  s = {RRR[c],CCC[r]}
  r = 8 - floor((t-1)/8)
  c = remainder(t,8)
  if c = 0 then
     c = 8
  end if
  s = s & {RRR[c],CCC[r]}
  p = pos[BOARD][t]
  if pos[CAPTURE] != 0 then
     if p > 1 then
        s = sprintf("%s",PIECES[p]) & s[1..2] & 'x' & s[3..4] 
     elsif p < -1 then
        s = sprintf("%s",PIECES[-p]) & s[1..2] & 'x' & s[3..4] 
     else
        s = s[1..2] & 'x' & s[3..4]
     end if
  else
     if p > 1 then
        s = sprintf("%s",PIECES[p]) & s[1..2] & '-' & s[3..4] 
     elsif p < -1 then
        s = sprintf("%s",PIECES[-p]) & s[1..2] & '-' & s[3..4] 
     else
        s = s[1..2] & '-' & s[3..4]
     end if
  end if
  return s 
end function

global function Move2text(integer m)
  integer f, t, r, c
  sequence s 
  s = {}
  f = floor(m/1000)
  t = remainder(m,1000)
  if t > 64 then
     return "Special move"
  end if
  r = 8 - floor((f-1)/8)
  c = remainder(f,8)
  if c = 0 then
     c = 8
  end if
  s = {RRR[c],CCC[r]}
  r = 8 - floor((t-1)/8)
  c = remainder(t,8)
  if c = 0 then
     c = 8
  end if
  s = s & {RRR[c],CCC[r]}
  return s 
end function

global function Text2move(object s)
  integer r,c,f,t
  if not compare(s,"e1g1") then
     return 61063
  elsif not compare(s,"e1c1") then
     return 61059
  elsif not compare(s,"e8g8") then
     return 5007
  elsif not compare(s,"e8c8") then
     return 5003
  elsif s[1] >= 'a' and s[1] <= 'h' and
     s[2] >= '1' and s[2] <= '8' and
     s[3] >= 'a' and s[3] <= 'h' and
     s[4] >= '1' and s[4] <= '8' then
     r = '8' - s[2]
     c = s[1] - 'a'+ 1
     f = 8*r + c
     r = '8' - s[4]
     c = s[3] - 'a' + 1 
     t = 8*r + c                      
  end if  
  return f*1000+t
end function                 

----------------------------------------------------------------------------

global function King_moves(sequence bd, integer loc, integer side)
  object x,m,c 
  x = DATA[loc][KING_MV]
  m = {}
  c = {}
  for i=1 to length(x) do
     if side = 1 then
        if bd[BOARD][x[i]] = 0 then
           m = m & x[i]
        elsif bd[BOARD][x[i]] <= BP then
           c =  c & x[i]
        end if
     elsif side = -1 then
        if bd[BOARD][x[i]] = 0 then
           m = m & x[i]
        elsif bd[BOARD][x[i]] >= WP then
           c =  c & x[i]              
        end if
     end if
  end for
  return loc*1000+c & loc*1000+m
end function 

global function Promotion(sequence bd, integer loc, integer side)
  object x,m,c
  m = {}
  c = {}
  if (side = WHITE_ and floor((loc-1)/8) != 1) or 
     (side = BLACK_ and floor((loc-1)/8) != 6) then  
     return {}
  end if
  if side = WHITE_ then  
     x = DATA[loc][WPAW_MV] 
     if length(x) = 1 then
        if bd[BOARD][x[1]] = 0 then
              m = m & x[1] + 100 & x[1] + 200 & x[1] + 300 & x[1] + 400
        end if
     end if
     x = DATA[loc][WPAW_CA]
     for i=1 to length(x) do
        if bd[BOARD][x[i]] <= BP then
              c = c & x[i] & 
                      x[i] + 100 & x[i] + 200 & x[i] + 300 & x[i] + 400
        end if 
     end for
  elsif side = BLACK_ and loc < 57 then
     x = DATA[loc][BPAW_MV]
     if length(x) = 1 then
        if bd[BOARD][x[1]] = 0 then
              m = m & x[1] + 500 & x[1] + 600 & x[1] + 700 & x[1] + 800
        end if
     end if
     x = DATA[loc][BPAW_CA]
     for i=1 to length(x) do
        if bd[BOARD][x[i]] >= WP then
              c = c & x[i] & 
                      x[i] + 500 & x[i] + 600 & x[i] + 700 & x[i] + 800
        end if 
     end for
  end if
  return loc*1000+c & loc*1000+m
end function 

global function Pawn_moves(sequence bd, integer loc, integer side)
  object x,m
  m = {}
  if side = WHITE_ and loc > 8 then  
     x = DATA[loc][WPAW_MV] 
     if length(x) = 1 then
        if bd[BOARD][x[1]] = 0 then
           m = m & x[1]
        end if
     else  
       if bd[BOARD][x[1]] = 0 then  --BUG here
           m = m & x[1]          
       end if
       if loc > 48 then
          if bd[BOARD][x[1]] = 0 and bd[BOARD][x[2]] = 0 then 
              m = m & x[2]          
          end if
       end if
     end if
  elsif side = BLACK_ and loc < 57 then
     x = DATA[loc][BPAW_MV]
     if length(x) = 1 then
        if bd[BOARD][x[1]] = 0 then
           m = m & x[1]
        end if
     else
       if bd[BOARD][x[1]] = 0 then           
          m = m & x[1]          
       end if
       if loc <= 16 then
          if bd[BOARD][x[1]] = 0 and bd[BOARD][x[2]] = 0 then 
              m = m & x[2]          
          end if
       end if
     end if
  end if
  return Promotion(bd,loc,side) & loc*1000+m
end function 


global function Knight_moves(sequence bd, integer loc, integer side)
  object x,m
  x = DATA[loc][Knig_MV]
  m = {}
  if side = WHITE_ then
     for i=1 to length(x) do
        if bd[BOARD][x[i]] = 0 then
           m = m & x[i]
        end if
     end for
  elsif side = BLACK_ then
     for i=1 to length(x) do
        if bd[BOARD][x[i]] = 0 then
           m = m & x[i]
        end if
     end for
  end if
  return loc*1000+m
end function                                                                 

global function Rook_moves(sequence bd, integer loc, integer side)
  object x,m
  x = DATA[loc][HORZ_MV]
  x = x & DATA[loc][VERT_MV]
  m = {}
  if side = WHITE_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] = 0 then
           m = m & x[WEST][i]
        elsif bd[BOARD][x[WEST][i]] <= BP then
           exit
        elsif bd[BOARD][x[WEST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] = 0 then
           m = m & x[EAST][i]
        elsif bd[BOARD][x[EAST][i]] <= BP then
           exit
        elsif bd[BOARD][x[EAST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] = 0 then
           m = m & x[NORTH][i]
        elsif bd[BOARD][x[NORTH][i]] <= BP then
           exit
        elsif bd[BOARD][x[NORTH][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] = 0 then
           m = m & x[SOUTH][i]
        elsif bd[BOARD][x[SOUTH][i]] <= BP then
           exit
        elsif bd[BOARD][x[SOUTH][i]] >= WP then
           exit
        end if
     end for     
  elsif side = BLACK_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] = 0 then
           m = m & x[WEST][i]
        elsif bd[BOARD][x[WEST][i]] >= WP then
           exit
        elsif bd[BOARD][x[WEST][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] = 0 then
           m = m & x[EAST][i]
        elsif bd[BOARD][x[EAST][i]] >= WP then
           exit
        elsif bd[BOARD][x[EAST][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] = 0 then
           m = m & x[NORTH][i]
        elsif bd[BOARD][x[NORTH][i]] >= WP then
           exit
        elsif bd[BOARD][x[NORTH][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] = 0 then
           m = m & x[SOUTH][i]
        elsif bd[BOARD][x[SOUTH][i]] >= WP then
           exit
        elsif bd[BOARD][x[SOUTH][i]] <= BP then
           exit
        end if
     end for     
  end if  
  return loc*1000+m
end function                  

global function Bishop_moves(sequence bd, integer loc, integer side)
  object x,m            
  x = DATA[loc][Diag_MV]
  m = {}
  if side = WHITE_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] = 0 then
           m = m & x[WEST][i]
        elsif bd[BOARD][x[WEST][i]] <= BP then
           exit
        elsif bd[BOARD][x[WEST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] = 0 then
           m = m & x[EAST][i]
        elsif bd[BOARD][x[EAST][i]] <= BP then
           exit
        elsif bd[BOARD][x[EAST][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] = 0 then
           m = m & x[NORTH][i]
        elsif bd[BOARD][x[NORTH][i]] <= BP then
           exit
        elsif bd[BOARD][x[NORTH][i]] >= WP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] = 0 then
           m = m & x[SOUTH][i]
        elsif bd[BOARD][x[SOUTH][i]] <= BP then
           exit
        elsif bd[BOARD][x[SOUTH][i]] >= WP then
           exit
        end if
     end for     
  elsif side = BLACK_ then
     for i=1 to length(x[WEST]) do
        if bd[BOARD][x[WEST][i]] = 0 then
           m = m & x[WEST][i]
        elsif bd[BOARD][x[WEST][i]] >= WP then
           exit
        elsif bd[BOARD][x[WEST][i]] <= BP then
           exit                     
        end if
     end for     
     for i=1 to length(x[EAST]) do
        if bd[BOARD][x[EAST][i]] = 0 then
           m = m & x[EAST][i]
        elsif bd[BOARD][x[EAST][i]] >= WP then
           exit
        elsif bd[BOARD][x[EAST][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[NORTH]) do
        if bd[BOARD][x[NORTH][i]] = 0 then
           m = m & x[NORTH][i]
        elsif bd[BOARD][x[NORTH][i]] >= WP then
           exit
        elsif bd[BOARD][x[NORTH][i]] <= BP then
           exit
        end if
     end for     
     for i=1 to length(x[SOUTH]) do
        if bd[BOARD][x[SOUTH][i]] = 0 then
           m = m & x[SOUTH][i]
        elsif bd[BOARD][x[SOUTH][i]] >= WP then
           exit
        elsif bd[BOARD][x[SOUTH][i]] <= BP then
           exit
        end if
     end for     
  end if  
  return loc*1000+m
end function                  

global function Queen_moves(sequence bd, integer loc, integer side)
  return Rook_moves(bd,loc,side) & Bishop_moves(bd,loc,side)
end function                  

global function Castling(sequence bd, integer side)
  object x
  if bd[CHECK] then
     return {}
  end if
  x = {} 
  if side = 1 then
     if bd[BOARD][61] = WK and bd[BOARD][64] = WR then
        if and_bits(bd[CASTLING],MASK_WCK) then
           if bd[BOARD][62] = 0 and bd[BOARD][63] = 0 and bd[BOARD][64] and
              not find(62,bd[BCONTROL]) and not find(63,bd[BCONTROL]) then
              x = append(x,61063)
           end if
        end if
     end if
     if bd[BOARD][61] = WK and bd[BOARD][57] = WR then
        if and_bits(bd[CASTLING],MASK_WCQ) then
           if bd[BOARD][58] = 0 and bd[BOARD][59] = 0 and bd[BOARD][57] and
              bd[BOARD][60] = 0 and 
              not find(59,bd[BCONTROL]) and not find(60,bd[BCONTROL]) then
              x = append(x,61059)
           end if
        end if
     end if
  elsif side = -1 then
     if bd[BOARD][5] = BK and bd[BOARD][8] = BR then
        if and_bits(bd[CASTLING],MASK_BCK) then
           if bd[BOARD][6] = 0 and bd[BOARD][7] = 0 and bd[BOARD][8] and
              not find(6,bd[WCONTROL]) and not find(7,bd[WCONTROL]) then
              x = append(x,5007)
           end if
        end if
     end if
     if bd[BOARD][5] = BK and bd[BOARD][1] = BR then
        if and_bits(bd[CASTLING],MASK_BCQ) then
           if bd[BOARD][2] = 0 and bd[BOARD][3] = 0 and bd[BOARD][1] and
              bd[BOARD][4] = 0 and
              not find(3,bd[WCONTROL]) and not find(4,bd[WCONTROL]) then
              x = append(x,5003)
           end if
        end if
     end if
  end if                          
  return x
end function 

global function Pawnhasmovedtwo(sequence bd, integer f, integer t)
  integer p
  p = bd[BOARD][t]
  if p = WP and (f-t) = 16 then
     return f-8
  elsif p = BP and (t-f) = 16 then
     return t-8
  end if
  return 0
end function    

