-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu
-- Program:  Chess (version 1.6a) 
-- Language: Euphoria
-- Author:   Normand M. Blais
-- Date:     August 1998
-- File:     pushbut.e
-- EuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEuEu

without warning
without type_check

include grutl.e
include image.e
include putsxy.e  -- Author: David Alan Cay

global constant NEW_BUTTON  = 1
global constant EXIT_BUTTON = 2

global constant NUM_BUTTON = 2

constant BUT_LOC         = 1
constant BUT_LABEL       = 2
constant BUT_COLOR_LABEL = 3
constant BUT_COLOR_BUT   = 4
constant BUT_VALUE       = 5
constant BUT_FLAG        = 6 -- 1 = active, 0 = inactive

global constant COLOR_LABEL  = YELLOW
global constant COLOR_BUTTON = CYAN

constant BUTTON_REC = {{0,0,0,0},   -- location (x,y,xlen,ylen)
                             " ",   -- label
                     COLOR_LABEL,
                    COLOR_BUTTON,       
                               0,   -- value
                               0}   -- activity flag

------------------------ DATA OBJECT
sequence buttons

global procedure Draw_button(integer but)
  integer width,height,len,x,y
  width  = buttons[but][BUT_LOC][3]
  height = buttons[but][BUT_LOC][4]
  len = length(buttons[but][BUT_LABEL])
  if width <= 8*len or height < 10 then
     return
  end if
  if buttons[but][BUT_FLAG] = 0 then
     buttons[but][BUT_COLOR_LABEL] = BRIGHT_RED
  else
     buttons[but][BUT_COLOR_LABEL] = BRIGHT_GREEN
  end if
  x = buttons[but][BUT_LOC][1] + floor((width - 8*len)/2)
  y = buttons[but][BUT_LOC][2] + floor((height-8)/3) 
  rectangle({buttons[but][BUT_LOC][1],buttons[but][BUT_LOC][2],
             width,height},buttons[but][BUT_COLOR_BUT],1)
  rectangle({buttons[but][BUT_LOC][1]-3,buttons[but][BUT_LOC][2]-3,
             width+6,height+6},CYAN,0)
  putsxy({x,y},buttons[but][BUT_LABEL],
         buttons[but][BUT_COLOR_LABEL],buttons[but][BUT_COLOR_BUT],0)
end procedure


------------------------ INTERFACE METHODS
-- Buttons are part of a set of controls

global procedure Init_controls(sequence s)
  buttons = repeat(BUTTON_REC,length(s)) 
  for i=1 to length(s) do
     buttons[i] = s[i]
  end for
end procedure

global procedure Controls(integer n)
  for i=1 to n do
     Draw_button(i)
  end for
end procedure

global procedure Put_color_but(integer but, integer color)
  buttons[but][BUT_COLOR_BUT] = color
end procedure

global procedure Put_color_label(integer but, integer color)
  buttons[but][BUT_COLOR_LABEL] = color
end procedure

global procedure Put_label_but(integer but, sequence new_label)
  buttons[but][BUT_LABEL] = new_label
end procedure

global procedure Put_status_but(integer but, integer n)
  buttons[but][BUT_FLAG] = n
end procedure

global procedure Put_value_but(integer but, integer n)
  buttons[but][BUT_VALUE] = n
end procedure

global function Get_status_but(integer but)
  return buttons[but][BUT_FLAG]
end function

global function Get_value_but(integer but)
  return buttons[but][BUT_VALUE]
end function

global function Get_loc_but(integer but)
  return buttons[but][BUT_LOC]
end function

global function Get_label_but(integer but)
  return buttons[but][BUT_LABEL]
end function
------------------------------------------------------------------------------
--include get.e

--object spare

--constant BUTTONS = {
--   {{400,100,70,30}, "NEW",  COLOR_LABEL,COLOR_BUTTON,0,1},
--   {{475,100,70,30}, "QUIT", COLOR_LABEL,COLOR_BUTTON,0,1}}

--Video()
--sequence coord

--Init_controls(BUTTONS)

--Controls(2)

--coord = {}       

--for i=1 to length(BUTTONS) do
--  coord = append(coord,Get_loc_but(i))
--end for

--spare = wait_key()

--Text()

